import Vue from 'vue';
import App from './App.vue';
import Vuex from 'vuex';
import VueRouter from 'vue-router';
import {routes} from './routes';
import Axios from 'axios';
import {store} from './store/store';

// Setting up axios as the default $http method  
// Docs at: https://github.com/axios/axios
Vue.prototype.$http = Axios;

// Setting up Router
Vue.use(VueRouter);
const router = new VueRouter({
  routes
})
import BootstrapVue from 'bootstrap-vue'
// Add bootstrap components globally:
import {
  Button, 
  Form, 
  FormCheckbox, 
  FormGroup, 
  FormInput,
  FormTextarea,
  Nav,
  Table,
  Card,
  Modal
} from 'bootstrap-vue/es/components/';
// Bootstrap base styles
import 'bootstrap/dist/css/bootstrap.css'
import 'bootstrap-vue/dist/bootstrap-vue.css'

Vue.use(BootstrapVue);
Vue.use(Button);
Vue.use(FormCheckbox);
Vue.use(FormGroup);
Vue.use(FormInput);
Vue.use(FormTextarea);
Vue.use(Form);
Vue.use(Nav);
Vue.use(Table);
Vue.use(Card);
Vue.use(Modal);

// Add Vuex imported above
Vue.use(Vuex);

// Setting up base url for axios
Axios.defaults.baseURL = 'https://vue-playground1.firebaseio.com';
Axios.defaults.headers.get['Accepts'] = 'application/json';

new Vue({
  el: '#app',
  router,
  store,
  render: h => h(App)
})
