import * as types from '../../types';

class DistributorClass {
    constructor() {
        //Setting the basic properties
        this.title = '';
        this.notes = '';
        this.contacts = [{
                name: '',
                email: '',
                phone: '',
            }];
    }
};

export default {
    [types.GET_CONTACTS]: state => (id) => {
        let contacts = [];
        if (id) {
            const dist = state.distributors.find(distributor => distributor.id === id)
            contacts = (dist && dist.contacts) ? dist.contacts : [];
        }
        return contacts;
    },
    [types.GET_CONTACT_FIELDS]: state => {
        let dist = new DistributorClass();
        let keys = Object.keys(dist.contacts[0]);
        keys = keys.filter(key=>key!=='uuid'); //Removing uuid column
        keys.push('actions'); //Adding Action column
        return keys;
    },
    [types.GET_DISTRIBUTORS]: state => {
        return state.distributors;
    },
    [types.GET_DISTRIBUTOR]: (state) => (id) => {
        let distributor;
        if (id) {
            distributor = state.distributors.find(distributor => distributor.id === id) || {};
        } else {
            distributor = new DistributorClass();
        }
        return distributor;
    },
    [types.GET_FIELDS]: state => {
        let keys = Object.keys(new DistributorClass());
        keys.push('actions'); //Adding Action column
        return keys;
    },
    [types.GET_ITEMS]: state => {
        let items = [];
        items = state.distributors.map(dist => {
            return {
                id: dist.id,
                title: dist.title,
                notes: dist.notes,
                contacts: dist.contacts ? dist.contacts.map( (contact, index) => {
                    return index === 0 ? contact.name : `, ${contact.name}`;
                }) : [],
            }
        });

        return items;
    },
};